import { Sequelize } from "sequelize-typescript";
import { User } from "./user";
import { ExerciseInstance } from "./exercise";

import { Page, Exercise, Grader } from "materialdb/db";

async function loadMaterialDb() {
  // TODO: ensure this database is read-only?
  // possibly could just chmod -w it at the start but that's kinda hacky
  let sequelize = new Sequelize(`sqlite:../materialdb/test.db`, {
    models: [Page, Exercise, Grader],
  });
  await sequelize.sync();
  return sequelize;
}

async function init(): Promise<Sequelize> {
  let sequelize = new Sequelize(`sqlite:test.db`, {
    models: [User, ExerciseInstance],
  });
  await sequelize.sync({ force: true });
  return sequelize;
}

export let dbPromise = init();
export let materialDb = loadMaterialDb();

export { User, ExerciseInstance };
